/******************************************************************************
;  *       @ͺ                 : MC51F7424
;  *       @             : 2022.12.07
;  *       @˾/            : ΢-AE
;  *       @΢           : http://www.sinomcu.com/
;  *       @Ȩ                 : ΢ ˾Ȩ.
;  *----------------------ժҪ---------------------------------
;  *                    ADC PWM
;  *  system clk 24MHz
;  *                     ------------
;  *        PWM-start-->|ADC-ch2(GND)|
;  *                    |ADC-ch1(LDO)|
;  *                    |ADC-ch0     |
;  *           | \            
;  *    P21 -->|P  \              | \    
;  *           |     > OPA*2----->|P  \
;  *           |N  /          |    |     > CMP--> PWM FB
;  *           | /            |    |N(DAC)
;  *                       ˿P20 | /
******************************************************************************/
#include "stdio.h"
#include "user.h"

extern idata uint16_t ADC_SR0,ADC_SR1,ADC_SR2;   // XDATAɨ
extern uint8_t ADC_FLAG;

//xdata uint16_t adc_val_buf[8] _at_ ADC_RESULT_ADD;

/************************************************
;  *    @            : main
;  *    @˵              : 
;  *    @          :
;  *    @ز          :
;  ***********************************************/
void main()
{
    DISABLE_GIE();                    // رж
    OSCSS &= 0x8F;                    // System Clock 24MHz
    GPIO_Init();
    ADC_Init();
    PWM1_Init(); 
    OPA0_Init();
    CMP1_Init();    
    UART1_Init(9600);
    ENABLE_GIE();                     // ж

    ADASCR0 |= 0x01;                  // ɨ蹦
    LED2 =HIGH;
    printf("***** OPA_CMP_ADC_PWM *****\r\n");
    printf("                     ------------                    \r\n");
    printf("        PWM-start-->|ADC-ch2(GND)|                   \r\n");
    printf("                    |ADC-ch1(LDO)|                   \r\n");
    printf("                    |ADC-ch0     |                   \r\n");
    printf("           | \\                                     \r\n");
    printf("    P21 -->|P  \\             | \\                  \r\n");
    printf("           |     > OPA*2------|P  \\                \r\n");
    printf("           |N  /          |    |     > CMP--> PWM FB \r\n");
    printf("           | /            |    |N(DAC)               \r\n"); 
    printf("                         P20   | /                   \r\n");
    printf("System Clock 24000000Hz.\r\n");
    while(1)
    {
        if(ADC_FLAG)
        {
            ADC_FLAG = 0;                 
            printf("ADC_SR0 =%x \r\n", ADC_SR0);
            printf("ADC_SR1 =%x \r\n", ADC_SR1);
            printf("ADC_SR2 =%x \r\n", ADC_SR2);
        }
    }
}
